/*
 * SolucionEjercicio12.java
 *
 * Creado el 20 de febrero de 2008, 22:43
 */


package computacion.practica2;

/**
 *
 * @author Vctor Jimnez
 *
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class SolucionEjercicio12 {
    
    public static void main(String[] args) {
        System.out.println("");
        System.out.println("Combinaciones de 29 elementos tomados de 14 en 14"
                + " por el primer mtodo: " + combinaciones(29, 14));
        System.out.println("Combinaciones de 29 elementos tomados de 14 en 14"
                + " por el segundo mtodo: " + combinaciones2(29, 14));
        System.out.println("Por qu? Porque el primer mtodo es incorrecto");          
        System.out.println("Combinaciones de 29 elementos tomados de 14 en 14"
                + " por el primer mtodo corregido: " 
                + combinacionesCorregido(29, 14));
    }

    public static int combinaciones(int m, int n) {
        double comb = 1.;
        
        for (int i = 0; i < n; i++) {
             comb = comb * (m - i) / (n - i);
        }               
        return (int) comb;
    }    
    
    /**
     * El mtodo combinaciones es incorrecto porque al redondear se trunca, 
     * no se aproxima al entero ms prximo. Para arreglarlo bastara sustituir
     *  return (int) comb;
     * por
     *  return (int) Math.round(comb);
     */
    public static int combinacionesCorregido(int m, int n) {
        double comb = 1.;
        
        for (int i = 0; i < n; i++) {
             comb = comb * (m - i) / (n - i);
        }               
        return (int) Math.round(comb);
    }
    
    public static int combinaciones2(int m, int n) {
        double comb = 1.;
        
        if ((m == n) || (n == 0)) {
            return 1;
        } else {
            return combinaciones2(m - 1, n - 1) + combinaciones2(m - 1, n);
        }                    
    }        
    
}
